import socket
from cryptography.hazmat.primitives import serialization
from cryptography.hazmat.backends import default_backend

import sys
import os

# ajouter le chemin vers le répertoire libs
libs_path = os.path.join(os.getcwd(), 'libs')
if libs_path not in sys.path:
    sys.path.append(libs_path)

# maintenant, vous pouvez importer votre bibliothèque
import paramiko
from paramiko.auth_handler import AuthHandler
import logging

import paramiko
import pexpect
from cryptography.hazmat.primitives import serialization
from cryptography.hazmat.backends import default_backend
import json

# From : https://stackoverflow.com/questions/287871/how-do-i-print-colored-text-to-the-terminal
class bcolors:
    HEADER = '\033[95m'
    OKBLUE = '\033[94m'
    OKCYAN = '\033[96m'
    OKGREEN = '\033[92m'
    WARNING = '\033[93m'
    FAIL = '\033[91m'
    ENDC = '\033[0m'
    BOLD = '\033[1m'
    UNDERLINE = '\033[4m'


with open('config.json', 'r') as f:
    config = json.load(f)

def main():
    # Obtenir les informations de connexion de l'utilisateur
    host = input('Veuillez entrer l\'hôte distant : ')
    username = input('Veuillez entrer le nom d\'utilisateur : ')
    # key = paramiko.RSAKey.from_private_key_file('ssh-keys/test')
    # Variables pour la clé publique
    public_key_file = config['keys']['pubkey_python']

    # Lire la clé publique au format OpenSSH
    with open(public_key_file, 'rb') as key_file:
        public_key = serialization.load_ssh_public_key(key_file.read(), backend=default_backend())


    # Créer une nouvelle session SSH
    ssh = paramiko.SSHClient()
    ssh.set_missing_host_key_policy(paramiko.AutoAddPolicy())
    
    print("Connexion au serveur distant...")
    print(bcolors.WARNING +"Veuillez confirmer la signature du défi sur l'appareil d'autorisation" + bcolors.ENDC)
    # Connecter au serveur distant

    try:
        ssh.connect(host, username=username)
    except paramiko.ssh_exception.SSHException:
        print(bcolors.FAIL +"Échec de l'authentification"+ bcolors.ENDC)
        return
    else:
        print(bcolors.OKGREEN + "Authentification réussie !" + bcolors.ENDC)

    # Ouvrir un shell interactif
    chan = ssh.invoke_shell()
    print("Shell interactif ouvert avec succès")

    # Si l'authentification est réussie, établir une nouvelle connexion SSH avec pexpect
    ssh_str = 'ssh %s@%s' % (username, host)
    child = pexpect.spawn(ssh_str)
    child.interact()  # pexpect offre une méthode interact() qui donne un shell interactif

    ssh.close()

    ssh.close()

if __name__ == '__main__':
    main()
