# Protype 1 : Python paramiko custom client

1. Generate simple rsa key into folder ssh-key
2. Make sure to have a host (A) and a server (B) that can connect trough SSH with this key
3. Have an authentication host (C) that can comunicate with host A
4. On authentication host C, have the ssh private and public key in the folder ssh-keys and install these dependencies :

pip3 install fastapi
pip3 install cryptography
pip3 install paramiko
pip3 install pydantic
pip3 install uvicorn

5. Make sure to edit file config.json with the correct informations
6. Launch host.py with the following command :

uvicorn auth:app --host 0.0.0.0 --port 8000

7. Make sure that the client host (A) does not have access to the private key. Only the public key should be present in the ssh-keys folder.
10. Launch the client with the following command :

python3 client.py

11. Enter hostname and username for the SSH connexion
12. A prompt should be showing on the authentication host, type yes to accept connexion. Enter passphrase if required
13. On the client host, connexion is established 

# Protype 2 : Custom OpenSSH agent

1. Generate simple rsa key into folder ssh-key
2. Make sure to have a host (A) and a server (B) that can connect trough SSH with this key
3. Have an authentication host (C) that can comunicate with host A
4. On authentication host C, have the ssh private and public key in the folder ssh-keys and install these dependencies :

pip3 install fastapi
pip3 install cryptography
pip3 install paramiko
pip3 install pydantic
pip3 install uvicorn

5. Make sure to edit file auth.py with the public key filename in the global public_key_file value and the private filename in the private_key_file
6. Launch host.py with the following command :

uvicorn auth:app --host 0.0.0.0 --port 8000

7. Make sure that the client host (A) does not have access to the private key. Only the public key should be present in the ssh-keys folder.
8. In the client host, edit the function process_sign_request2 in the openssh-portable/ssh-agent.c file and replace the path of the public key in the pubkey_path variable.
9. Compile program with command "make"
10. Launch the ssh-agent with the command ./ssh-agent -d (to have a debug console)
11. The process shoud output two commands like : 

SSH_AUTH_SOCK=/tmp/ssh-XXXXXXqIumy4/agent.8211; export SSH_AUTH_SOCK;

Launch them in a terminal.

12. Edit the ~/.ssh/config file with the following line, replacing the value with the socket generated above :

IdentityAgent /tmp/ssh-XXXXXXqIumy4/agent.8211

13. Make sure to add a private key to agent that links to nothing (for debug purposes). Generate new rsa-key if needed.

ssh-add <key>

14. In a new terminal, launch the agentForwarder with the following command :

python3 python/agentForwarder.py

15. Now, if you try to connect to a remote host with a simple ssh command, the signature will be done in the authentication host, passing trough the agentForwarder.py. You can see the unsigned / signed payload going trough in the agentForwarder console.
