import socket
import requests
import json
import binascii
import base64

# Créer un socket
s = socket.socket(socket.AF_INET, socket.SOCK_STREAM)

# Lie le socket à un port spécifique
s.bind(('localhost', 8083))

# Commence à écouter le port
s.listen(1)

print('Le serveur écoute sur le port 8083...')

while True:
    # Accepte une connexion
    client, address = s.accept()

    print('Connexion établie avec : ', address)

    # Lecture des données envoyées par le client
    data = client.recv(1024)
    data_hex = binascii.hexlify(data).decode()
    
    print('Reçu : ', data)

    # Envoi des données à l'API FastAPI
    response = requests.post(
        "http://192.168.1.24:8000/sign2",
        headers={"Content-Type": "application/json"},
        data=json.dumps({"data": data_hex})
    )

    print("Réponse de l'API FastAPI: ", response.json())

    # Extraction de la signature depuis la réponse JSON
    response_json = response.json()
    signed_data_base64 = response_json.get("signed_data", "")

    # Décoder la signature de base64
    signed_data_bytes = base64.b64decode(signed_data_base64)

    # Convertir en hexadécimal
    signed_data_hex = signed_data_bytes.hex()

    # Convert hexadecimal signed data to bytes
    signed_data_bytes = bytes.fromhex(signed_data_hex)
    print("Sending to socket : ")
    print(signed_data_bytes)

    # Send the signed data to the client
    client.send(signed_data_bytes)

# Ferme la connexion
client.close()
